#include <iostream>

using namespace std;

   double vectorSum( const double* x, int n, int from, int upto )
   {
      int m;
      double sum( 0 );

      for ( m = from; m <= upto; m = m + 1 )  sum = sum + x[m];
      return sum;
   } // vectorSum

   int maxPos( const int x[], int n, int from, int upto )
   {
      int m;
      int mxp;

      if ( from < 0 || upto < from || n <= upto )
         mxp = -1;
      else // 0 <= from <= upto <= n-1
      {
         mxp = from;
         for ( m = from+1; m <= upto; m = m + 1 )
         {
            if (x[m] > x[mxp])  mxp = m;
         } // for (m ...
      }
      return mxp;
   } // maxPos

int main()
{
   const int N( 9 ), Nd2( N/2 );

   double x[N] = { 5.5, 6.3, 4, -3, 5.1, -13, 0, -15.7, 3.75 },
          u[Nd2] = { 5.5, 4, 5.1, 0 };
   int ix[N] = { 5, 6, 4, -3, 1, -13, 0, -15, 3 },
       iu[Nd2] = { 5, 4, 1, 0 };

   int m;
   cout << " x:  ";
   for (m = 0; m <= N-1; m = m + 1)  cout << x[m] << "  ";
   cout << endl;

   cout << " x: " << vectorSum( x, N, 0, N-1 ) << endl;

   cout << " max(ix): " << ix[maxPos(ix, N, 0, N-1)]
        << "  : " << maxPos( ix, N, 0, N-1 ) << endl;
   cout << " max(iu): " << iu[maxPos(iu, Nd2, 0, Nd2-1)]
        << "  : " << maxPos( iu, Nd2, 0, Nd2-1 ) << endl;
        
   cout << " x: " << vectorSum( x, N, N-1, 0 ) << endl;
   cout << "  : " << maxPos( ix, N, N-1, 0 ) << endl;
} // main


